package com.grupogodo.corp.projects.optimus.app.trigger;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.ApplicationListener;
import org.springframework.context.event.ContextRefreshedEvent;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;

import com.grupogodo.corp.projects.optimus.services.PopulatorService;


@Component
public class DBInitBean implements ApplicationListener<ContextRefreshedEvent> {

    @Autowired
    private PopulatorService populatorService;

    @Value("${eclipselink.ddl-generation}")
    private String ddlGeneration;
    
    @Override
    @Transactional
    public void onApplicationEvent(ContextRefreshedEvent event) {
        if (!ddlGeneration.equalsIgnoreCase("none") && !populatorService.isPopulated()) {
            populatorService.populate();
        }
    }
}