package com.grupogodo.corp.projects.optimus.composers.popups;

import java.util.*;

import javax.annotation.PostConstruct;

import lombok.*;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.context.annotation.ScopedProxyMode;
import org.springframework.stereotype.Component;
import org.zkoss.spring.SpringUtil;
import org.zkoss.zk.ui.select.annotation.Listen;
import org.zkoss.zkplus.databind.DataBinder;
import org.zkoss.zul.ListModelList;
import org.zkoss.zul.Window;

import com.grupogodo.corp.libs.springzk.spring.*;
import com.grupogodo.corp.libs.zkcomponents.components.autocomplete.model.AbstractAutocompleteModel;
import com.grupogodo.corp.libs.zkcomponents.components.window.GWindow;
import com.grupogodo.corp.projects.optimus.entities.*;
import com.grupogodo.corp.projects.optimus.services.ProcessService;
import com.grupogodo.corp.projects.optimus.services.TaskService;

@Component
@Scope(value = "prototype", proxyMode = ScopedProxyMode.NO)
public class TaskPopupComposer extends ZKModelAwareComposer<Window> {

    private static final long serialVersionUID = -8910862036480279542L;

    public static void openWindow(ScheduledTask task, ZKCrossComposer<ScheduledTask> taskComposer) {
        TaskPopupComposer taskPopupComposer = SpringUtil.getApplicationContext().getBean(TaskPopupComposer.class);
        taskPopupComposer.setScheduledTask(task);
        taskPopupComposer.setTaskComposer(taskComposer);

        Map<String, Object> parameters = new HashMap<String, Object>();
        parameters.put("composer", taskPopupComposer);
        GWindow.doModal("/WEB-INF/views/popups/taskEditPopup.zul", parameters);
    }

    @AllArgsConstructor
    public class ProcessModel extends AbstractAutocompleteModel<ProcessDefinition> {

        private static final long serialVersionUID = -3904829875795930214L;

        private ProcessService processService;

        @Override
        public List<ProcessDefinition> suggest(String pattern) {
            return processService.suggest(pattern);
        }

        @Override
        public ProcessDefinition createInstance(String string) {
            // TODO Auto-generated method stub
            return null;
        }

        @Override
        public void validate(ProcessDefinition object) throws ValidationException {
            // TODO Auto-generated method stub

        }

    }

    @Setter(AccessLevel.PRIVATE)
    private ZKCrossComposer<ScheduledTask> taskComposer;

    @Autowired
    private TaskService taskService;

    @Autowired
    private ProcessService processService;

    @Getter
    private ListModelList<ScheduledTask> taskModel = new ListModelList<ScheduledTask>();

    @Getter
    private ProcessModel processModel;

    @Getter
    @Setter(AccessLevel.PRIVATE)
    private Execution execution;

    @Getter
    @Setter(AccessLevel.PRIVATE)
    private ProcessDefinition processDefinition;

    @Getter
    @Setter(AccessLevel.PRIVATE)
    private ScheduledTask scheduledTask;

    @Getter
    private Exception exception;

    @PostConstruct
    public void init() {
        taskModel.addAll(taskService.findAll());
        processModel = new ProcessModel(processService);
    }

    @Listen("onSubmit = #taskEditWindow")
    public void onSubmit(ScheduledTask task, DataBinder dataBinder) {

        validate(task, dataBinder);
        taskComposer.onSubmit(task, dataBinder);
        // TODO grabar execution
    }

    @Listen("onCancel = #taskEditWindow")
    public void onCancel(ScheduledTask task) {
        taskComposer.onCancel(task);
    }

}
