package com.grupogodo.corp.projects.optimus.config;

import java.util.Properties;

import lombok.val;

import org.springframework.beans.factory.config.PropertiesFactoryBean;
import org.springframework.beans.factory.config.PropertyPlaceholderConfigurer;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.core.io.ClassPathResource;
import org.springframework.core.io.Resource;

@Configuration
public class Config {

    private static final String ENCODING = "UTF-8";

    @Bean
    public PropertiesFactoryBean properties() {
        val bean = new PropertiesFactoryBean();
        bean.setFileEncoding(ENCODING);
        bean.setLocations(new Resource[] { new ClassPathResource("optimus.properties"), new ClassPathResource("app.properties"),
                new ClassPathResource("mail.properties") });
        return bean;
    }
    
    @Bean
    public PropertyPlaceholderConfigurer propertyPlaceholderConfigurer(Properties properties) {
        PropertyPlaceholderConfigurer bean = new PropertyPlaceholderConfigurer();
        bean.setProperties(properties);
        bean.setIgnoreUnresolvablePlaceholders(true);
        return bean;
    }
}
