package com.grupogodo.corp.projects.optimus.controllers;

import lombok.val;

import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.servlet.ModelAndView;

@Controller
public class MainController {

    @RequestMapping({"", "/"})
    public String dashboard() {
        return "dashboard";
    }

    @RequestMapping("/executions")
    public String executions() {
        return "executions";
    }
    
    @RequestMapping("/process")
    public String process() {
        return "process";
    }

    @RequestMapping("/process/{processDefinitionName}")
    public ModelAndView process(@PathVariable String processDefinitionName) {
        val mav = new ModelAndView("process");
        mav.addObject("processDefinitionName", processDefinitionName);
        return mav;
    }

    @RequestMapping("/scheduledTasks")
    public String scheduledTasks() {
        return "scheduledTasks";
    }

}
