package com.grupogodo.corp.projects.optimus.entities;

import java.util.Date;

import javax.persistence.*;

import lombok.*;

import com.grupogodo.corp.libs.jpa.core.BaseEntity;
import com.grupogodo.corp.projects.optimus.enums.ExecutionResult;

@Entity
@Getter
@Setter
@NoArgsConstructor
public class Execution extends BaseEntity {

    @ManyToOne(optional = false)
    private ProcessDefinition processDefinition;

    @Temporal(TemporalType.TIMESTAMP)
    private Date executionDate;

    @OneToOne(cascade = CascadeType.ALL)
    private ExecutionException executionException;

    @ManyToOne
    private ScheduledTask scheduledTask;

    private ExecutionResult executionResult;
    
    public Execution(ProcessDefinition processDefinition, Date executionDate, ExecutionResult executionResult) {
        this.processDefinition = processDefinition;
        this.executionDate = executionDate; 
        this.executionResult = executionResult;
    }
    
    public Execution(ProcessDefinition process, Date executionDate, ExecutionResult executionResult, ScheduledTask scheduledTask) {
        this(process, executionDate, executionResult); 
        this.scheduledTask = scheduledTask;
    }
    
    public Execution(ProcessDefinition process, Date executionDate, ExecutionResult executionResult, ScheduledTask scheduledTask, ExecutionException exception) {
        this(process, executionDate, executionResult, scheduledTask); 
        this.executionException = exception;
    }
}
