package com.grupogodo.corp.projects.optimus.entities;

import java.util.*;

import javax.persistence.*;

import lombok.*;

import com.grupogodo.corp.libs.jpa.core.BaseEntity;

@Entity
@Getter
@Setter
@Table(name = "GROUP_")
@NoArgsConstructor
public class Group extends BaseEntity {

    private String name;

    private String description;

    private boolean menu;

    @ManyToOne
    private Group parent;

    @ManyToMany(fetch = FetchType.EAGER)
    private Set<ProcessDefinition> processes = new HashSet<ProcessDefinition>();

    @ManyToMany(cascade = CascadeType.ALL)
    private List<UserPermission> permissions = new LinkedList<UserPermission>();

    private boolean deleted = false;

    public Group(String name) {
        this.name = name;
    }

    public Group(String name, String description, boolean menu, Group parent) {
        this(name);
        this.description = description;
        this.menu = menu;
        this.parent = parent;
    }
}
