package com.grupogodo.corp.projects.optimus.entities;

import java.util.ArrayList;
import java.util.List;

import javax.persistence.*;

import lombok.*;

import org.hibernate.validator.constraints.NotBlank;

import com.grupogodo.corp.libs.jpa.core.BaseEntity;

@Entity
@Getter
@Setter
@Inheritance(strategy = InheritanceType.SINGLE_TABLE)
@Table(uniqueConstraints = @UniqueConstraint(columnNames = "name"))
@NoArgsConstructor
public class ProcessDefinition extends BaseEntity {

    @NotBlank
    private String name;

    // Relaciona ProcessDefinition amb Processor
    private String bean;

    private String description;

    private boolean executable;
    
    private boolean deleted;

    @OneToMany(fetch = FetchType.EAGER, cascade = CascadeType.ALL, orphanRemoval = true, mappedBy = "processDefinition")
    private List<Parameter> parameters = new ArrayList<Parameter>();
    
    public ProcessDefinition(String name, String bean, String description, boolean executable) {
        this.name = name;
        this.bean = bean;
        this.description = description;
        this.executable = executable;
    }
}
