package com.grupogodo.corp.projects.optimus.entities;

import java.util.*;

import javax.persistence.*;

import lombok.*;

import com.grupogodo.corp.libs.jpa.core.BaseEntity;
import com.grupogodo.corp.libs.util.validation.constraints.CronExpression;

@Entity
@Getter
@Setter
@NoArgsConstructor
public class ScheduledTask extends BaseEntity {

    private String name;

    @CronExpression
    private String cronExpression;
    
    @Temporal(TemporalType.TIMESTAMP)
    private Date lastExecution;
    
    @Temporal(TemporalType.TIMESTAMP)
    private Date nextExecution;
    
    private long repeatInterval;

    @ManyToMany(fetch = FetchType.EAGER, cascade = CascadeType.ALL)
    private List<ProcessDefinition> processDefinitions = new LinkedList<ProcessDefinition>();
    
    public ScheduledTask (String name, String cronExpression ){
        this.name =name;
        this.cronExpression = cronExpression;
    }

}
