package com.grupogodo.corp.projects.optimus.repositories.impl;

import com.grupogodo.corp.libs.jpa.core.JpaDefaultRepository;
import com.grupogodo.corp.projects.optimus.entities.*;
import com.grupogodo.corp.projects.optimus.repositories.ExecutionExceptionRepository;
import com.mysema.query.jpa.impl.JPAQuery;

public class ExecutionExceptionRepositoryImpl extends JpaDefaultRepository<ExecutionException, Long> implements ExecutionExceptionRepository {

    private static final QExecutionException executionException = QExecutionException.executionException;
    
    @Override
    public ExecutionException findByExecution(Execution execution) {
        JPAQuery query = createQuery().where(executionException.execution.eq(execution));
        return findOne(query);
    }

    @Override
    public ExecutionException findByProcessDefinition(ProcessDefinition processDefinition) {
        JPAQuery query = createQuery().where(executionException.processDefinition.eq(processDefinition));
        return findOne(query);
    }

}
