package com.grupogodo.corp.projects.optimus.repositories.impl;

import java.util.List;

import org.springframework.data.repository.query.Param;

import com.grupogodo.corp.libs.jpa.core.JpaDefaultRepository;
import com.grupogodo.corp.projects.optimus.entities.*;
import com.grupogodo.corp.projects.optimus.repositories.ExecutionRepository;
import com.mysema.query.jpa.impl.JPAQuery;

public class ExecutionRepositoryImpl extends JpaDefaultRepository<Execution, Long> implements ExecutionRepository {

    private static final QExecution execution = QExecution.execution;
    
    @Override
    public List<Execution> findAllByProcessDefinition(@Param("processDefinition") ProcessDefinition processDefinition) {
        JPAQuery query = createQuery().where(execution.processDefinition.eq(processDefinition));
        return findAll(query);
    }

}
