package com.grupogodo.corp.projects.optimus.repositories.impl;

import java.util.List;

import lombok.val;

import com.grupogodo.corp.libs.jpa.core.JpaDefaultRepository;
import com.grupogodo.corp.projects.optimus.entities.Group;
import com.grupogodo.corp.projects.optimus.entities.QGroup;
import com.grupogodo.corp.projects.optimus.repositories.GroupRepository;

public class GroupRepositoryImpl extends JpaDefaultRepository<Group, Long> implements GroupRepository {
    
    private static final QGroup group = QGroup.group;

    public List<Group> findByParent(Group parent) {
        if (parent == null) {
            val predicate = group.parent.isNull().and(group.deleted.isFalse());
            return findAll(predicate, group.name.asc());
        }
        val predicate = group.parent.eq(parent).and(group.deleted.isFalse());
        return findAll(predicate, group.name.asc());
    }
}
