package com.grupogodo.corp.projects.optimus.repositories.impl;

import java.util.List;
import java.util.Set;

import lombok.val;

import com.grupogodo.corp.libs.jpa.core.JpaDefaultRepository;
import com.grupogodo.corp.projects.optimus.entities.*;
import com.grupogodo.corp.projects.optimus.repositories.ProcessRepository;

public class ProcessRepositoryImpl extends JpaDefaultRepository<ProcessDefinition, Long> implements ProcessRepository {

    private final QProcessDefinition processDefinition = QProcessDefinition.processDefinition;

    @Override
    public ProcessDefinition findByName(String name) {
        return findOne(createQuery().where(processDefinition.name.eq(name)));
    }

    @Override
    public Set<ProcessDefinition> findByGroup(Group group) {

        return group.getProcesses();
    }

    @Override
    public List<ProcessDefinition> suggest(String pattern) {
        val query = createQuery().where(processDefinition.name.like("%" + pattern + "%"));
        return findAll(query);
    }
}
