package com.grupogodo.corp.projects.optimus.services.impl;

import java.util.*;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.grupogodo.corp.libs.common.domain.*;
import com.grupogodo.corp.projects.optimus.entities.*;
import com.grupogodo.corp.projects.optimus.repositories.*;
import com.grupogodo.corp.projects.optimus.services.ExecutionExceptionService;

@Service
@Transactional(readOnly = true)
public class ExecutionExceptionServiceImpl implements ExecutionExceptionService {

    @Autowired
    private ExecutionExceptionRepository executionExceptionRepository;

    @Override
    public List<ExecutionException> findAll() {

        return executionExceptionRepository.findAll();
    }

    @Override
    @Transactional
    public ExecutionException save(ExecutionException execution) {

        return executionExceptionRepository.save(execution);
    }

    @Override
    public void delete(ExecutionException execution) {

        executionExceptionRepository.delete(execution);
    }

    @Override
    public ExecutionException get(Long id) {

        return executionExceptionRepository.findOne(id);
    }

    @Override
    public Page<ExecutionException> find(Collection<Filter> filters, Pageable pageable) {

        return executionExceptionRepository.find(filters, pageable);
    }

    @Override
    public ExecutionException findByExecution(Execution execution) {
        return executionExceptionRepository.findByExecution(execution);
    }

    @Override
    public ExecutionException findByProcessDefinition(ProcessDefinition processDefinition) {
        return executionExceptionRepository.findByProcessDefinition(processDefinition);
    }

}
