package com.grupogodo.corp.projects.optimus.services.impl;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.grupogodo.corp.projects.optimus.entities.*;
import com.grupogodo.corp.projects.optimus.repositories.*;
import com.grupogodo.corp.projects.optimus.services.ParameterService;

@Service
@Transactional(readOnly = true)
public class ParameterServiceImpl implements ParameterService {

    @Autowired
    private ProcessRepository processRepository;

    @Autowired
    private ParameterRepository parameterRepository;

    @Override
    @Transactional
    public Parameter save(Parameter parameter) {
        return parameterRepository.save(parameter);
    }

    @Override
    @Transactional
    public void delete(Parameter parameter) {

        parameterRepository.delete(parameter);
    }

    @Override
    public List<Parameter> findByProcess(ProcessDefinition process) {
        return parameterRepository.findByProcess(process);
    }

    @Override
    public List<Parameter> findAll() {
        // TODO Auto-generated method stub
        return parameterRepository.findAll();
    }
}
