package com.grupogodo.corp.projects.optimus.services.impl;

import java.util.List;
import java.util.Set;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.grupogodo.corp.projects.optimus.entities.Group;
import com.grupogodo.corp.projects.optimus.entities.ProcessDefinition;
import com.grupogodo.corp.projects.optimus.repositories.ProcessRepository;
import com.grupogodo.corp.projects.optimus.services.ProcessService;

@Service
public class ProcessServiceImpl implements ProcessService {

    @Autowired
    private ProcessRepository processRepository;

    @Override
    @Transactional
    public ProcessDefinition save(ProcessDefinition process) {
        return processRepository.save(process);
    }

    @Override
    public List<ProcessDefinition> findAll() {
        return processRepository.findAll();
    }

    @Override
    @Transactional
    public void delete(ProcessDefinition process) {
        process.setDeleted(true);
        save(process);
    }

    @Override
    public Set<ProcessDefinition> findByGroup(Group group) {
        return processRepository.findByGroup(group);
    }

    @Override
    public ProcessDefinition findOne(Long id) {
        return processRepository.findOne(id);
    }

    @Override
    public List<ProcessDefinition> suggest(String pattern) {
        return processRepository.suggest(pattern);
    }
}
