package com.grupogodo.corp.projects.optimus.services.impl;

import java.util.Collection;
import java.util.List;

import lombok.RequiredArgsConstructor;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.grupogodo.corp.libs.common.domain.*;
import com.grupogodo.corp.projects.optimus.entities.ScheduledTask;
import com.grupogodo.corp.projects.optimus.repositories.TaskRepository;
import com.grupogodo.corp.projects.optimus.services.TaskService;


@Service
public class TaskServiceImpl implements TaskService {

    @RequiredArgsConstructor
    private class TriggerExecutor implements Runnable {

        private final TaskService service;
        private final ScheduledTask task;

        public void run() {
            service.execute(task);
        }
    }
    
    @Autowired
    private TaskRepository taskRepository;

    @Override
    @Transactional
    public ScheduledTask save(ScheduledTask scheduledTask) {
        return taskRepository.save(scheduledTask);
    }

    @Override
    public List<ScheduledTask> findAll() {
        return taskRepository.findAll();
    }

    @Override
    @Transactional
    public void delete(ScheduledTask scheduledTask) {
        taskRepository.delete(scheduledTask);
    }

    @Override
    public ScheduledTask get(Long id) {

        return taskRepository.findOne(id);
    }

    @Override
    public Page<ScheduledTask> find(Collection<Filter> filters, Pageable pageable) {

        return taskRepository.find(filters, pageable);
    }

    @Override
    public void execute(ScheduledTask scheduledTask) {
        // TODO Auto-generated method stub
        
        
    }

}
