package com.grupogodo.corp.projects.optimus.services.impl;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.grupogodo.corp.projects.optimus.entities.Group;
import com.grupogodo.corp.projects.optimus.entities.UserPermission;
import com.grupogodo.corp.projects.optimus.services.UserPermissionService;
import com.grupogodo.corp.projects.optimus.repositories.UserPermissionRepository;

@Service
@Transactional
public class UserPermissionServiceImpl implements UserPermissionService {

    @Autowired
    private UserPermissionRepository userPermissionRepository;

    @Override
    public UserPermission save(UserPermission permissions) {
        return userPermissionRepository.save(permissions);
    }

    @Override
    public List<UserPermission> findAll() {
        
        return userPermissionRepository.findAll();
    }

    @Override
    public void delete(UserPermission permissions) {

        userPermissionRepository.delete(permissions);

    }

    @Override
    public List<UserPermission> findByGroup(Group group) {

        return userPermissionRepository.findByGroup(group);
    }

}
