package com.grupogodo.corp.projects.optimus.services.processor;

import java.util.List;

/**
 * Interfície que han d'implementar tots els processors.
 * 
 * @author fdeobes
 *
 */
public interface Processor {

    boolean isExtraParametersAllowed();
    /**
     * Noms dels paràmetres necessaris per a executar el procés.
     * @return
     */
    List<ParameterInfo> getParameters();

    /**
     * Executa el procés usant les dades del context
     * @param context
     * @return
     */
    Object execute(ProcessorContext context);

    /**
     * Retorna un String per fer un preview amb estructura reconeguda
     * @param context
     * @return
     */
    String preview(ProcessorContext context);

}
