package com.grupogodo.corp.projects.optimus.services.processor;

import java.util.HashMap;

/**
 * Es tracta de les dades que necessita un procés per a executar-se. Poden obtenir-se de la base de dades (de l'entitat Parameter) o també
 * es poden passar entre processos.
 * 
 * Extensió d'un Map<String, Object> amb mètodes per a facilitar-nos la vida.
 * 
 * @author fdeobes
 * 
 */
@SuppressWarnings("serial")
public class ProcessorContext extends HashMap<String, Object> {

    @SuppressWarnings("unchecked")
    public <T> T get(String key, Class<T> clss) {
        return (T) this.get(key);
    }

    public String getString(String key) {
        Object value = get(key);
        if (value == null) {
            return null;
        }
        return value == null ? null : value.toString();
    }

    public Integer getInteger(String key) {
        Object value = get(key);
        if (value == null) {
            return null;
        }
        if (value instanceof Number) {
            return ((Number) value).intValue();
        }
        return Integer.parseInt(value.toString());
    }

}
