package com.grupogodo.corp.projects.optimus.services.processor.impl;

import java.util.Arrays;
import java.util.List;

import javax.sql.DataSource;

import lombok.SneakyThrows;

import org.springframework.jdbc.datasource.SingleConnectionDataSource;
import org.springframework.stereotype.Component;

import com.grupogodo.corp.projects.optimus.services.processor.*;
import com.grupogodo.corp.projects.optimus.services.processor.ParameterInfo.ParameterType;

/**
 * Obté un datasource a partir de la url, usuari i password.
 * 
 * @author fdeobes
 * 
 */
@Component
public class DataSourceProcessor extends AbstractProcessor {

    @Override
    public List<ParameterInfo> getParameters() {
        return Arrays.asList( //
                new ParameterInfo("url", ParameterType.STRING), //
                new ParameterInfo("user", ParameterType.STRING), //
                new ParameterInfo("password", ParameterType.STRING));
    }

    @Override
    @SneakyThrows
    public DataSource execute(ProcessorContext map) {
        return new SingleConnectionDataSource(map.getString("url"), map.getString("user"), map.getString("password"), false);
    }

}
