package com.grupogodo.corp.projects.optimus.service.processor;

import java.util.Arrays;

import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;

import com.grupogodo.corp.projects.optimus.config.ServiceConfig;
import com.grupogodo.corp.projects.optimus.entities.Parameter;
import com.grupogodo.corp.projects.optimus.entities.ProcessDefinition;
import com.grupogodo.corp.projects.optimus.services.ProcessService;
import com.grupogodo.corp.projects.optimus.services.processor.ProcessorExecutor;

@RunWith(SpringJUnit4ClassRunner.class)
@ContextConfiguration(classes = ServiceConfig.class)
public class ColabTest {

    @Autowired
    private ProcessorExecutor executor;

    @Autowired
    private ProcessService service;

    @Test
    public void test() {

        ProcessDefinition processDefinition = new ProcessDefinition();
        processDefinition.setName("colabPreDataSource");
        processDefinition.setBean("dataSourceProcessor");
        processDefinition.setParameters(Arrays
                .asList(par(
                        "url",
                        "jdbc:oracle:thin:@(DESCRIPTION = (LOAD_BALANCE=on)(ADDRESS_LIST =(ADDRESS =(PROTOCOL = TCP)(HOST = 192.168.34.6)(PORT = 1521))(ADDRESS =(PROTOCOL = TCP)(HOST = 192.168.34.7)(PORT = 1521)))(CONNECT_DATA = (SERVICE_NAME = DGRIDDES)))"),
                        par("user", "colab"), par("password", "colab")));
        service.save(processDefinition);

        processDefinition = new ProcessDefinition();
        processDefinition.setName("colabQueryExecutor");
        processDefinition.setBean("sqlQueryProcessor");
        processDefinition.setParameters(Arrays.asList(par("dataSource", "colabPreDataSource"),
                par("query", "select * from hermesentry where author = :author")));
        service.save(processDefinition);

        processDefinition = new ProcessDefinition();
        processDefinition.setName("colabFinalProcess");
        processDefinition.setBean("velocityProcessor");
        processDefinition.setParameters(Arrays
                .asList(par(
                        "template",
                        "#set($res = ${executor.execute('colabQueryExecutor', {'author': 'EVALLEJO'})}) Result:\n#foreach($r in $res) $r.id\t $r.hermesId\t $r.publicationDate\n#end")));
        service.save(processDefinition);

        Object result = executor.execute("colabFinalProcess");
        System.out.println(result);
    }

    private Parameter par(String key, String value) {
        Parameter par = new Parameter();
        par.setKey(key);
        par.setValue(value);
        return par;
    }
}
